stages:
  - build

variables:
  RELEASE_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
  LATEST_IMAGE: $CI_REGISTRY_IMAGE

# build image
build:
  image: docker:latest
  stage: build
  variables:
    DOCKER_DRIVER: overlay2
  services:
    - docker:dind
  before_script:
    - docker info
  script:
    - docker login -u "gitlab-ci-token" -p $CI_BUILD_TOKEN $CI_REGISTRY
    - (docker pull $RELEASE_IMAGE && docker build --cache-from $RELEASE_IMAGE -t $RELEASE_IMAGE .) ||
      (docker pull $LATEST_IMAGE && docker build --cache-from $LATEST_IMAGE -t $RELEASE_IMAGE .) ||
      docker build -t $RELEASE_IMAGE .
    - docker push $RELEASE_IMAGE

